Crystal::Macros::Path - Crystal 1.10.1

# class Crystal::Macros::Path

- Crystal::Macros::Path
- Crystal::Macros::ASTNode

##
Overview

A Path to a constant or type, like `Foo` or `Foo::Bar::Baz`.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #global : BoolLiteral

  Returns `true` if this is a global path (starts with `::`)

  DEPRECATED Use `#global?` instead

- #global? : BoolLiteral

  Returns `true` if this is a global path (starts with `::`)

- #names : ArrayLiteral(MacroId)

  Returns an array with each separate part of this path.

- #resolve : ASTNode

  Resolves this path to a `TypeNode` if it denotes a type, to the value of a constant if it denotes a constant, or otherwise gives a compile-time error.

- #resolve? : ASTNode | NilLiteral

  Resolves this path to a `TypeNode` if it denotes a type, to the value of a constant if it denotes a constant, or otherwise returns a `NilLiteral`.

- #types : ArrayLiteral(ASTNode)

  Returns this path inside an array literal.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def global : BoolLiteral #

Returns `true` if this is a global path (starts with `::`)

DEPRECATED Use `#global?` instead

def global? : BoolLiteral #

Returns `true` if this is a global path (starts with `::`)

def names : ArrayLiteral(MacroId) #

Returns an array with each separate part of this path.

def resolve : ASTNode #

Resolves this path to a `TypeNode` if it denotes a type, to the value of a constant if it denotes a constant, or otherwise gives a compile-time error.

def resolve? : ASTNode | NilLiteral #

Resolves this path to a `TypeNode` if it denotes a type, to the value of a constant if it denotes a constant, or otherwise returns a `NilLiteral`.

def types : ArrayLiteral(ASTNode) #

Returns this path inside an array literal. This method exists so you can call `#types` on the type of a type declaration and get all types, whether it's a Generic, Path or Union.